
--			SQL alapok

-- biblio adatbzis (SQL serveren:  pubs_access)

-- 193.6.41.217 

--a New York-i szkhely kiadk neve

--a legnaqyobb szletsi v

-- a legfiatalabb szerz neve
select * from authors
where [year born] in (select max([year born]) from authors)

--New Yorkban kiadott knyvek cme
select t.title, [Company Name], city, p.pubid
from publishers p inner join titles t on p.pubid=t.pubid
where city='New York'

--Bramer, Susan ltal is rt, New Yorkban kiadott knyvek cme
select t.title, [Company Name], city, p.pubid --ha it nem lenne p alias, hiba lenne
from publishers p inner join titles t on p.pubid=t.pubid
where city='New York' and t.isbn in 
	(select isbn 
	from titleauthor ta inner join authors a on ta.au_id=a.au_id
	where a.author like 'Bramer%')

--ugyanez mshogy
select distinct t.title, [Company Name], city, p.pubid
from publishers p inner join titles t on p.pubid=t.pubid
inner join titleauthor ta on ta.isbn=t.isbn
inner join authors a on ta.au_id=a.au_id
where city='New York' and a.author like 'Bramer%'

--melyik kiadnak nem jelent meg knyve?
select * --, [Company Name], city, p.pubid
from publishers p left outer join titles t on p.pubid=t.pubid
where t.isbn is null
order by p.pubid

-- NORTHWIND ADATBZISRA TLLS
--ki hany uzletet kotott?

select e.lastname, count(orderid) as rend_szama
--count(*) kihozott volna Lamernek is egy rendelst
from employees e left outer join orders o on 
--from employees e inner join orders o on 
e.employeeid = o.employeeid
group by e.employeeid, e.lastname
order by count(*) desc

--ki nem kttt mg zletet?
select e.*
from employees e left outer join orders o on 
e.employeeid = o.employeeid
where o.orderid is null

--ki kinek a fnke? (Northwind) (3 szintig)
select dolg.lastname as dolg_neve, fonok.lastname as fonok_neve, 
nagyfonok.lastname as nagyfonok_neve
from employees dolg left outer join employees fonok 
on dolg.reportsto=fonok.employeeid
left outer join employees nagyfonok 
on fonok.reportsto=nagyfonok.employeeid

--megrendelsek fsszege, melyik a legrtkesebb rendels?
select o.orderid as rend_szama, 
	cast(o.orderdate as varchar(50)) as rend_datuma, 
	str(sum((1-discount)*unitprice*quantity), 15, 2) as rend_osszege,
	sum(quantity) as darabok_szama,
	count(d.orderid) as tetelek_szama
from orders o inner join [order details] d on o.orderid=d.orderid
group by o.orderid, o.orderdate
--order by o.orderdate
order by sum((1-discount)*unitprice*quantity) desc

--ido szerinti rendezskor: group by o.orderid, o.orderdate

--melyik gynk hozta a legtbb pnzt? Hny rendelsbol?

select  u.titleofcourtesy+' '+u.lastname+' '+ u.firstname +' ('+u.title +')'  as nev, 
--select u.lastname as nev, 
str(sum((1-discount)*unitprice*quantity), 15, 2) as behozott_penz,
count(o.orderid) as rendelesek_szama
from orders o inner join [order details] d on o.orderid=d.orderid
	inner join employees u on u.employeeid=o.employeeid
group by u.employeeid, u.titleofcourtesy, u.title, u.lastname, u.firstname
--megfigyelni: emp.id szerint is kell group, br nem rdekel minket, mert 
--lehetnek azonos nevu gynkk
--having count(o.orderid)>200 --ha csak a 200-nl tbb megrendelsu gynkk rdekelnek
order by sum((1-discount)*unitprice*quantity) desc

--gyan: csak 9 gynknk van?

select count(*) from employees

--ltszik, hogy 10!
--akkor ki nem kttt egy zletet sem?
--az gynklista aljn 0-val szerepeljenek azok is, akikhez nincs rendels

select  u.titleofcourtesy+' '+u.lastname+' '+ u.firstname +' ('+u.title +')'  as nev, 
isnull(str(sum((1-discount)*unitprice*quantity), 15, 2), 0) as behozott_penz,
count(o.orderid) as rendelesek_szama
from employees u left outer join 
	(orders o inner join [order details] d on o.orderid=d.orderid)
on u.employeeid=o.employeeid
--where u.titleofcourtesy='Mr.' --ha csak a frfiak rdekelnek
group by u.employeeid, u.titleofcourtesy, u.title, u.lastname, u.firstname
order by sum((1-discount)*unitprice*quantity) desc

--lebukott.

--melyik a legkeresettebb termk?
select p.productid, p.productname, count(*) as hanyszor_szerepel,
	sum(quantity) as ossz_darabszam
from products p left outer join [order details] d on p.productid=d.productid
group by p.productid, p.productname
order by count(*) desc

--melyik gynk adta el a legtbbet a legkeresettebb termkbol?
--elso valtozat
select u.titleofcourtesy+' '+u.lastname+' '+ u.firstname +' ('+u.title +')'  as nev, 
	sum(quantity) as hanyat_adott_el
from orders o inner join [order details] d on o.orderid=d.orderid
	inner join employees u on u.employeeid=o.employeeid
where d.productid = 59 --mr tudjuk, hogy ez a nyer termk
group by u.employeeid, u.titleofcourtesy, u.title, u.lastname, u.firstname
order by sum(quantity) desc

--s vgl:
--melyik gynk adta el a legtbbet a legkeresettebb termkbol s mi az?
--ezt mindenki nllan csinlja meg!!

select top 1 u.titleofcourtesy+' '+u.lastname+' '+ u.firstname +' ('+u.title +')'  as nev, 
	sum(quantity) as hanyat_adott_el
	,pr.productname as mibol
from orders o inner join [order details] d on o.orderid=d.orderid
	inner join employees u on u.employeeid=o.employeeid
	inner join products pr on pr.productid=d.productid
where d.productid = 
	(select top 1 p.productid
	from products p left outer join [order details] d on p.productid=d.productid
	group by p.productid, p.productname
	order by count(*) desc)
group by u.employeeid, u.titleofcourtesy, u.title, u.lastname, u.firstname
, pr.productname  --ha ltni akarjuk azt is, hogy mi a legkeresettebb termk
		--nem okozhat hibt, mert a where elobb szr, mint a group
order by sum(quantity) desc

--szorgalmi SELECT feladatok:
--a legjobb zletkt milyen termkbl adott el a legtbbet?

--a havonta kttt zletek szma zletktnknt s havonknt

select e.employeeid, lastname, cast(year(orderdate) as varchar(4)) +'_'+  cast(month(orderdate) as char(2)) as honap, count(orderid) as rend_szam
from employees e left outer join orders o on e.employeeid=o.employeeid
group by e.employeeid, lastname, cast(year(orderdate) as varchar(4)) +'_'+  cast(month(orderdate) as char(2))
order by lastname, honap

--egyszerbben:
select e.employeeid, lastname, year(orderdate) as ev, month(orderdate) as honap, count(orderid) as rend_szam
from employees e left outer join orders o on e.employeeid=o.employeeid
group by e.employeeid, lastname, year(orderdate), month(orderdate)
order by lastname, ev, honap

--u.ez kozmetikzva (case szerkezet)
select e.employeeid, lastname, 
case 
	when month(orderdate) < 10 then cast(year(orderdate) as varchar(4)) +'_0'+  cast(month(orderdate) as char(2)) 
	when month(orderdate) >= 10 then cast(year(orderdate) as varchar(4)) +'_'+  cast(month(orderdate) as char(2)) 
	else 'N.A'
end as honap,
count(orderid) as rend_szam
from employees e left outer join orders o on e.employeeid=o.employeeid
group by e.employeeid, lastname, 
case 
	when month(orderdate) < 10 then cast(year(orderdate) as varchar(4)) +'_0'+  cast(month(orderdate) as char(2)) 
	when month(orderdate) >= 10 then cast(year(orderdate) as varchar(4)) +'_'+  cast(month(orderdate) as char(2)) 
	else 'N.A'
end
order by lastname, honap

--a havonta tlagosan kttt zletek szma zletktnknt, ki a legjobb?

drop table #tt

select e.employeeid, lastname, cast(year(orderdate) as varchar(4)) +'_'+  cast(month(orderdate) as char(2)) as honap, count(orderid) as rend_szam
into #tt
from employees e left outer join orders o on e.employeeid=o.employeeid
group by e.employeeid, lastname, cast(year(orderdate) as varchar(4)) +'_'+  cast(month(orderdate) as char(2))
order by lastname, honap

select * from #tt

select lastname, str(avg(cast(rend_szam as float)), 15, 2) as atlagos_rend_szam
from #tt group by employeeid, lastname
order by atlagos_rend_szam desc

--FELADATOK
--tlagosan hny rendelst kt nlunk egy gynk?--erre mr temp.tbla kell.

--ki produklt legalbb msflszer akkora bevtelt, mint a fnke?

--RDEKESSG : rekord <-> mez talakts SQL union s case segtsgvel
--alkalmazs: esemnyorientlt <-> hagyomnyos modell talakts
-- (ezt ksbb kurzorokkal is megcsinljuk)

--a plda 3 szretel brigd eredmnye 5 nap alatt

CREATE TABLE [dbo].[csapat] (
	[csapat_id] [int] NOT NULL ,
	[csapat_nev] [nvarchar] (50) NOT NULL 
) 

CREATE TABLE [dbo].[eredm_heti] (
	[csapat_id] [int] NOT NULL ,
	[e_hetfo] [int] NULL ,
	[e_kedd] [int] NULL ,
	[e_szerda] [int] NULL ,
	[e_csut] [int] NULL ,
	[e_pentek] [int] NULL 
) 

CREATE TABLE [dbo].[eredm_napi] (
	[csapat_id] [int] NOT NULL ,
	[nap_id] [int] NOT NULL ,
	[eredm] [int] NOT NULL 
) 

CREATE TABLE [dbo].[nap] (
	[nap_id] [int] NOT NULL ,
	[nap_nev] [nvarchar] (50) NOT NULL 
) 

select * from eredm_napi
select * from eredm_heti

--MEGOLDS:

select csapat_nev, nap_nev,  e_hetfo as eredm, nap.nap_id --a nap_nev kivalasztasahoz kell a nap join
from eredm_heti eh inner join csapat cs on cs.csapat_id=eh.csapat_id inner join nap on 1=nap_id 
union
select csapat_nev, nap_nev,  e_kedd as eredm, nap.nap_id
from eredm_heti eh inner join csapat cs on cs.csapat_id=eh.csapat_id inner join nap on 2=nap_id 
union
select csapat_nev, nap_nev,  e_szerda as eredm, nap.nap_id
from eredm_heti eh inner join csapat cs on cs.csapat_id=eh.csapat_id inner join nap on 3=nap_id 
union
select csapat_nev, nap_nev,  e_csut as eredm, nap.nap_id
from eredm_heti eh inner join csapat cs on cs.csapat_id=eh.csapat_id inner join nap on 4=nap_id 
union
select csapat_nev, nap_nev,  e_pentek as eredm, nap.nap_id
from eredm_heti eh inner join csapat cs on cs.csapat_id=eh.csapat_id inner join nap on 5=nap_id 
order by csapat_nev, nap.nap_id

--VIEW
create view vi_hetibol_napi as
select top 1000 csapat_nev, nap_nev,  e_hetfo as eredm, nap.nap_id
from eredm_heti eh inner join csapat cs on cs.csapat_id=eh.csapat_id inner join nap on 1=nap_id 
union
select top 1000  csapat_nev, nap_nev,  e_kedd as eredm, nap.nap_id
from eredm_heti eh inner join csapat cs on cs.csapat_id=eh.csapat_id inner join nap on 2=nap_id 
union
select top 1000  csapat_nev, nap_nev,  e_szerda as eredm, nap.nap_id
from eredm_heti eh inner join csapat cs on cs.csapat_id=eh.csapat_id inner join nap on 3=nap_id 
union
select top 1000  csapat_nev, nap_nev,  e_csut as eredm, nap.nap_id
from eredm_heti eh inner join csapat cs on cs.csapat_id=eh.csapat_id inner join nap on 4=nap_id 
union
select top 1000  csapat_nev, nap_nev,  e_pentek as eredm, nap.nap_id
from eredm_heti eh inner join csapat cs on cs.csapat_id=eh.csapat_id inner join nap on 5=nap_id 
order by csapat_nev, nap.nap_id

GO

create view vi_napibol_heti as 
select csapat_nev, 
sum(case 
	when nap_id=1 then eredm
	else null
end)  as e_hetfo,
sum(case 
	when nap_id=2 then eredm
	else null
end)  as e_kedd,
sum(case 
	when nap_id=3 then eredm
	else null
end)  as e_szerda,
sum(case 
	when nap_id=4 then eredm
	else null
end)  as e_csut,
sum(case 
	when nap_id=5 then eredm
	else null
end)  as e_pentek
from eredm_napi en inner join csapat cs on cs.csapat_id=en.csapat_id
group by en.csapat_id, csapat_nev




--			Gyakorlatok adatbzis-objektumokkal

--Enterprise manager indtsa, belps diak* nven
--jelsz megvltoztatsa
--a stupido2000.mdb tblinak importlsa az abkr-admin knyvtrbl az adatbzisba
--kulcsok, kls kulcsok helyrelltsa a diagramszerkesztvel
--kulcs, kls kulcs knyszerek ellenrzse a tbla szerkesztsekor
--knyszer elhelyezse az egyenleg mezre (>=0) s a dtum mezre (<getdate())
--ennek tesztelse a Query Analyzerrel (hibt akarunk kivltani)

--		eddig jutottunk el az okt. 5-i rn

--update, delete, insert szintaxisa, kiprblsa a sajt adatbzisban

update vsrl set egyenleg=0  where vrosnv like 'H%'

--update from: j irszm mez felvtele a vsrl tblba,
--kitltse a Vros tblbl

update vsrl set irszm='ismeretlen'
select * from vsrl

--kln figyelmet rdemel az "update from" --egyik tblbl a msikba trni valamilyen
--informcit

update vsrl set irszm=vs.irszm
from vsrl v inner join vros vs on v.vrosnv=vs.vrosnv

--insert

insert vsrl (vsrlnv, vrosnv, egyenleg) 
values ('prba', 'Lukafa', 25)

--masolat keszizese a Vsrl tblrl, eredeti trlse majd visszalltsa
--ideiglenes tblk haszna s hasznlata, select ... into

select * into t2 from vsrl
delete vsrl
insert vsrl select * from t2

--a visszalltskor mindenki egyenlege 0 legyen
--ehhez kell: konstans a select listban
--plda:
select vsrlnv, 5 as konstans , getdate() from vsrl

--teht: a visszalltskor mindenki egyenlege 0 legyen

delete vsrl
insert  vsrl select Vsrlnv, vrosnv, 0, null from t2
select * from vsrl

--"show execution plan" a Query Analyzerben a legbonyolultabb lekrdezsre 
--	(melyik gynk adta el a legtbbet a legkeresettebb termkbol)
-- megfigyelni: a szrsek a fa leveleinl vannak, hogy az adatszerkezetek kicsik legyenek


--			DDL
--create table gyakorlsa

create table proba (id int not null, nev varchar(51))
insert proba values (5, 'nv')
select * from proba

--view ksztse: leghsgesebb vsrlnk kedvenc szlltja (kzzel)

create view vi_vasarlo as
select distinct vsrlnv + ' ' + vrosnv as vnev from vsrl

--megfigyelni: distinct hatsa (ha csak vsrlnv lenne)

select * from vi_vasarlo



--				T-SQL gyakorlatok



--T-SQl vltozk: @i
--T-SQL vezrlsi szerkezetek: if, while
--scriptek elemei (pl. print)

--pelda ciklusra: adjuk ossze a szamokat 1-tol n-ig
set nocount on
declare @i int, @eredm int
set @i=1
set @eredm=0
while @i<=23 begin
	set @eredm=@eredm+@i
	set @i=@i+1
end

select 'a szmok sszege: '+cast(@eredm as varchar(15))
print 'a szmok sszege: '+cast(@eredm as varchar(15))
select @eredm
select 'eredmny'
go
select rand()
--megjegyzes: Hungarian notation

--feladat: 1. egy uj tbla ltrehozsa, 2. 100 vletlen float rtkkel feltltse
--3. listzsa s 4. trlse
--"generate SQL script" egy bonyolult Northwind tblra, kls kulccsal,indexekkel
--j anyag: if exists 

declare @i int
--if exists: haladknak
if exists (select * from dbo.sysobjects 
		where id = object_id('[dbo].[veletlen]') 
		and OBJECTPROPERTY(id, 'IsUserTable') = 1)
	drop table [dbo].[veletlen]

create table veletlen (szam float)
set @i=1
while @i<=100 begin
	insert veletlen (szam) values (100*rand())
	set @i=@i+1
end
select * from veletlen
drop table veletlen



-- PLDA ZLETI FOLYAMATRA: egy Northwind rendelst vigynk vgig!
-- a.) termk kikeresse (keress nv alapjn)
-- b.) kosr sszelltsa (termk s mennyisg megadsa)
-- c.) rendels sszrtknek kiszmolsa, jvhagys
--    (van-e r fedezet, van-e elg raktron?)
-- d.) raktrkszlet s gyfl egyenleg mdostsa
-- e.) sttuszjelents (a tranzakci sikeres vagy sem...)

-- a.) termk kikeresse:
declare @nev varchar(20), @statusz_leiras varchar(100);
declare @talalatok_szama int, @mennyiseg int;
declare @termekkod int, @statusz int;
declare @raktarkeszlet int, @ugyfel varchar(10);

set @nev = 'boston';
set @mennyiseg = 7;
set @ugyfel = 'arout';

-- ha egy termket tall, akkor adja vissza a kulcsot
select @talalatok_szama = count(*) from northwind.dbo.products
		where productName like '%' + @nev + '%'	;
if @talalatok_szama = 1
	begin
		select @termekkod = productID from northwind.dbo.products
			where productName like '%' + @nev + '%'
		set @statusz = 1;
		set @statusz_leiras = 'Egy tallat: ' + cast(@termekkod as varchar(10));		
	end
else
	begin 
		set @statusz = 0;
		set @statusz_leiras = 'Tbb tallat - szktse a keressi felttelt!';
	end

-- b.) amig lehet, addig a KULCSokkal dolgozunk!
if @statusz = 1
	begin
		-- van-e raktron? avagy, a rendelt mennyisg elrhet-e?
		select @raktarkeszlet = unitsInStock from northwind.dbo.products
			where productID = @termekkod

		if @raktarkeszlet >= @mennyiseg		
			begin
				set @statusz = 2;
				set @statusz_leiras = @statusz_leiras + ' Van elg raktron.';
			end

		else
			begin
				set @statusz_leiras = @statusz_leiras + ' Nincs elg raktron.';
			end
end

-- ==================================
-- mennyibe kerl? Van elg pnze a vevnek?
-- ==================================
declare @egyenleg int, @osszeg money;
if @statusz = 2
	begin
		select @egyenleg = balance from customers where customerid = @ugyfel
		select @osszeg = unitPrice * @mennyiseg from northwind.dbo.products
			where productID = @termekkod
		if @egyenleg >= @osszeg
			begin
				set @statusz = 3  -- van r pnz
				set @statusz_leiras = @statusz_leiras + 
				' Van r fedezet.';
			end
		else
			begin
				set @statusz_leiras = @statusz_leiras + 
				' Nincs r fedezet!';
			end
-----
-- eddig minden rendben: egy termk, ven raktron, van r fedezet
if @statusz = 3
	begin
	-- j bejegyzs az Orders, Order Details tblkba
-- az OrderID automatikus sorszmozs, 
-- j rekord beszrsa utn vissza kell krdeznnk az j rtket
-- s ezzel a kulcsrtkkel kell az Order Details tblba bejegyezni
-- a rendelt termket
		declare @rendelesszam int;
		insert into orders(customerID, orderdate)
		values (@ugyfel, getdate())

		set @rendelesszam = @@identity

		insert into [order details](orderid, productid, quantity)
		values(@rendelesszam, @termekkod, @mennyiseg);

		-- frissts a Products.UnitsInStock, Customers.Balance mezk
		update products
		set unitsInStock = unitsInStock - @mennyiseg
		where productid = @termekkod;

		set @statusz_leiras = @statusz_leiras + ' Sikeres vsrls!'
	end


end 

print @statusz_leiras;

update products set unitsInStock = 9 where productid=40

-- hiba: ha egyszerre tbb konkurrens krs rkezik, akkor 
-- ez a feldolgozs ellentmondsba viszi az adatbzist.
-- megolds: szervezzk egy megszakthatatlan egysgg, 
-- tranzakciv (lsd ksbb).

--				tarolt eljarasok
drop procedure t2
create procedure t2
@i int
as 
declare @j int
set @j=2
select * from northwind.dbo.employees where employeeid = @i+@j

go
--tesztels:
t2 4

--nll feladat: korbbi vletlen szmos feladatunk megvalstsa trolt eljrsknt

create procedure sp_veletlen
@hany_szam int
as
declare @i int
--if exists: haladknak
if exists (select * from dbo.sysobjects 
		where id = object_id('[dbo].[veletlen]') 
		and OBJECTPROPERTY(id, 'IsUserTable') = 1)
	drop table [dbo].[veletlen]

create table veletlen (szam float)
set @i=1
while @i<=@hany_szam begin
	insert veletlen (szam) values (100*rand())
	set @i=@i+1
end
select * from veletlen
drop table veletlen

go

exec sp_veletlen 250

-- 			felhasznli fggvnyek
--elz megoldsunk a forgalom havi bontsra nem valami elegns:
select e.employeeid, lastname, 
case 
	when month(orderdate) < 10 then cast(year(orderdate) as varchar(4)) +'_0'+  cast(month(orderdate) as char(2)) 
	when month(orderdate) >= 10 then cast(year(orderdate) as varchar(4)) +'_'+  cast(month(orderdate) as char(2)) 
	else 'N.A'
end as honap,
count(orderid) as rend_szam
from employees e left outer join orders o on e.employeeid=o.employeeid
group by e.employeeid, lastname, 
case 
	when month(orderdate) < 10 then cast(year(orderdate) as varchar(4)) +'_0'+  cast(month(orderdate) as char(2)) 
	when month(orderdate) >= 10 then cast(year(orderdate) as varchar(4)) +'_'+  cast(month(orderdate) as char(2)) 
	else 'N.A'
end
order by lastname, honap

--definialjunk ra felhasznaloi fuggvenyt!
drop function ev_honap
create function ev_honap (@datum datetime)  
returns varchar(50) AS  
begin 
declare @eredm varchar(50)
set @eredm = case 
	when month(@datum) < 10 then cast(year(@datum) as varchar(4)) +'_0'+  cast(month(@datum) as varchar(2)) 
	when month(@datum) >= 10 then cast(year(@datum) as varchar(4)) +'_'+  cast(month(@datum) as varchar(2)) 
	else 'N.A'
end
return @eredm
end

--igy mar szebb:

select e.employeeid, lastname, dbo.ev_honap(orderdate) as honap,
count(orderid) as rend_szam
from employees e left outer join orders o on e.employeeid=o.employeeid
group by e.employeeid, lastname, dbo.ev_honap(orderdate)
order by lastname, honap

--nll feladat: rjunk fggvnyt, amely kt, datetime tpus vltoz kzl 
--visszaadja a korbbit, ha valamelyik null, akkor pedig a 'N.A.' stringet
--tesztels az orders tbln
--sajt adatbzisbl az orders elrse
use ab5
select top 1 * from northwind.dbo.orders

--					kurzorok

--pelda kurzorra: rekord-mezo atalakitas (tranzakcionlis alakra hozs)
--figyelem: use
use northwind
select * from employees
declare @emp_id int, @emp_name nvarchar(50), @i int, @address nvarchar(60),
	@city nvarchar(50)
create table #eredm (adatid int, dolg_id int, 
		adatnev varchar(50), adatertek nvarchar(100))
declare cursor1 cursor
	for 
	select employeeid as emp_id, firstname+' '+lastname as emp_name,address, city 
	from employees

set @i=0
open cursor1
fetch next from cursor1 into @emp_id, @emp_name, @address, @city
while @@fetch_status = 0
begin
	--print @emp_id print @emp_name print @i
	if @emp_name is not null begin
		insert #eredm values(@i, @emp_id, 'dolgozo_neve', @emp_name)
		set @i=@i+1
	end
	if @address is not null begin
		insert #eredm values(@i, @emp_id, 'dolgozo_cime', @address)
		set @i=@i+1
	end
	if @city is not null  begin
		insert #eredm values(@i, @emp_id, 'dolgozo_varosa', @city)
		set @i=@i+1
	end
	fetch next from cursor1 into @emp_id, @emp_name, @address, @city

	print @emp_id
end
close cursor1 
deallocate cursor1
print 'feldolgozs vge'
select * from #eredm
drop table #eredm
GO

--EXEC master.dbo.sp_cursor_list 'cursor1'

--feladat:
--kurzort rni az Orders/Order details tblkra: a 100$ alatti rendelseket kln tblba rni
--ezt meg lehetne csinlni egy select mondattal is de most a kurzort gyakoroljuk

--problema: nincs jogunk a northwind-ben tablat letrehozni
--megoldas: masik adatb. egy tablajanak az elerese az osveny segitsegevel
select top 10  * from northwind.dbo.orders

--egyik tarolt aljaras hivasa egy masikbol,
--OUTPUT parameterek hasznalata

alter procedure sp_veletlen
@hany_szam int
as
declare @i int, @k float, @k2 float
--if exists: haladknak
if exists (select * from dbo.sysobjects 
		where id = object_id('[dbo].[veletlen]') 
		and OBJECTPROPERTY(id, 'IsUserTable') = 1)
	drop table [dbo].[veletlen]

create table veletlen (szam float)
set @i=1
while @i<=@hany_szam begin
	set @k=	100*rand()
	exec sp_ketszerez @k, @eredm=@k2 output
	insert veletlen (szam) values (@k2)
	set @i=@i+1
end
select * from veletlen
drop table veletlen

create  procedure sp_ketszerez
@be float,
@eredm float output
as
set @eredm=2*@be
go

sp_veletlen 100


--				Tranzakcik

		--batch (kteg) kt GO utasts kztt

--T-SQL vltozk csak a ktegen bell rvnyesek
--DDL, pl alter table hatsa csak a GO utn rezheto
--egy script tbb kteget is tartalmazhat: ha valamelyikben hiba van, veszi a kvetkezot


--drop table pelda 
create table pelda (szam int)
insert pelda values (44)
go

--1. kiserlet
update pelda set szam=22
go
selec * from pelda --szintaktikai hiba
go
select * from pelda
--eredmeny 22, mert az elso batch sikerult

--ugyanez egy batch-ben
delete pelda
insert pelda values (44)
go

--2. kiserlet
update pelda set szam=22
selec * from pelda --szintaktikai hiba
go
select * from pelda
--eredmeny 44 
--mert szintaktikai hiba esetn az egsz batchbl semmi sem hajtdik vgre

--DE!
--ha az objektumnev hianyzik (nem parse hiba), akkor nem szamit a batch:
delete pelda
insert pelda values (44)
go

--3. kiserlet
update pelda set szam=22
select * from plda --Invalid object name
go
select * from pelda
--eredmeny 22
go
--PEDIG MIND A KTSZER CSAK EGY BETUT HAGYTUNK KI!

--ACID tulajdonsgok
	--atomicity: nem valsulhat meg rszlegesen
	--consistency: utna konzisztens llapotban marad az AB (pl. kenyszerek teljesulnek)
	--isolation: prhuzamosan fut tr.k nem ltjk egymst (szintjei vannak)
	--durability: a logols miatt a commit utn, ha a commit csak a 
	--	memriban trtnt meg a rendszerhibakor, 
	--	akkor is kirdik az j adat file-ba a kvetkezo indulskor
	--	log (ldf) tartalma: logikai uatsts, before/after image (nagyobb lehet, mint az ab.)
		

				--implicit tranzakci

--drop table pelda2
--drop table pelda3
set nocount on 
create table pelda2 (id int not null, szam int)
insert pelda2 values (0, 44)
insert pelda2 values (1, 44)
insert pelda2 values (2, 44)
create table pelda3 (id int not null, pelda2_id int)
insert pelda3 values (1, 1)
insert pelda3 values (2, 1)
--kls kulcs knyszer a kett kz:
alter table pelda2 add constraint pk_1 primary key (id) 
alter table pelda3 add constraint pk_2 primary key (id) 
alter table pelda3 add constraint fk_1 foreign key  (pelda2_id)  references pelda2 (id)

go

declare @hibakod int
delete pelda2 --ez annyi logikai trls, ahny rekordja van 
-- nem trli az 1. es 3. rekordot, mert a 2. trlsekor hiba volt!!

--	HIBAKEZELS
set @hibakod=@@error
if @hibakod <> 0 print 'HIBA! hibakd: '+cast(@hibakod as varchar(10))

--megjegyzs:
if @@error <> 0 print 'HIBA! hibakd: '+cast(@@error as varchar(10))
--ez nem mukdne, mert az if utasts nem volt hibs...

select * from pelda2 
go
--mindharom rekord megvan


		-- "igazi", azaz explicit tranzakcik

set xact_abort off
--begin tran, commit tran, rollback tran
begin tran
print @@trancount
--itt egy hiba:
delete from pelda2
--commit tran 
--elfelejtjk a commit-ot...
go
--ezutn VIGYZAT:
print @@trancount
-- 1, teht beslt a tr. (igen nagy hiba lehet belole!!)
--megolds kzzel:
rollback tran
print @@trancount
-- most mr 0

go

--ehelyett hasznld az xact_abortot
set xact_abort on 	-- 	" Specifies whether Microsoft SQL Server automatically rolls back the 
			--	current transaction if a Transact-SQL statement raises a run-time error"
			--vagy minden insert, cast, update, delete stb. utn a @@error vizsglata
--go
begin tran
print 'eloszr: ' + cast(@@trancount as varchar)
--itt egy hiba:
delete from pelda2
--ezrt ide mr nem jut el:
commit tran
go
							--if @@trancount>0 rollback tran
--ezutn:
print 'vgl: ' + cast(@@trancount as varchar)
-- ez 0

--nll feladat: 3 insert utastssal demonstrlni a tr. rollback-ot, a hiba a 2.-nl legyen
set nocount on
--drop table t2
--drop table t1
go
CREATE TABLE t1 (a int PRIMARY KEY)
CREATE TABLE t2 (a int REFERENCES t1(a))
GO
INSERT INTO t1 VALUES (1)
INSERT INTO t1 VALUES (3)
INSERT INTO t1 VALUES (4)
INSERT INTO t1 VALUES (6)
GO
SET XACT_ABORT OFF
GO
BEGIN TRAN
delete t2
INSERT INTO t2 VALUES (1)
INSERT INTO t2 VALUES (2) /* Foreign key error */
INSERT INTO t2 VALUES (3)
COMMIT TRAN
GO
print 'eloszr: ' + cast(@@trancount as varchar) //trancount = 0, teht commit-olt
/* Select shows only keys 1 and 3 added. 
   Key 2 insert failed and was rolled back, but
   XACT_ABORT was OFF and rest of transaction
   succeeded.*/
select * from t2

SET XACT_ABORT ON
GO
delete t2
BEGIN TRAN
INSERT INTO t2 VALUES (4)
INSERT INTO t2 VALUES (5) /* Foreign key error */
INSERT INTO t2 VALUES (6)
COMMIT TRAN
GO
print 'vgn: ' + cast(@@trancount as varchar)


/* Key 5 insert error with XACT_ABORT ON caused
   all of the second transaction to roll back. */

SELECT * FROM t2
GO

--zarak szintjei:
--	rekord
--	lap (4KB)
--	kulcs
--	index
--	tabla
--	adatb.

--zarak tipusai:
--	shared (read)
--	exlusive (write)
--	update (shared->excl)
--	(intent)

--izolacios szintek:
--	serializable
--	repeatable read
--	read committed
--	read uncommitted

--tranzakci izolcis szintek demonstrcija
create table termek(id int primary key, eladva varchar(50), kinek varchar(50))
insert termek(id, eladva) values (1, 'nincs eladva')
insert termek(id, eladva) values (2, 'nincs eladva')
select * from termek
update termek set eladva='nincs eladva', kinek=null where id=2
go
set tran isolation level read committed --ez a default
go
begin tran
declare @eladva varchar(50)
select @eladva=eladva from termek where id=2 -- vizsgalat
if @eladva='nincs eladva' begin
	waitfor delay '00:00:10' --most terheljk az illet bankszmljt
	update termek set eladva='eladva', kinek='A' where id=2
	print 'elads megtrtnt'
end else print 'elads sikertelen'
commit tran
go

--egy masik kapcsolatot nyitni, ezzel a koddal:
--set tran isolation level read committed --ez a default
--set tran isolation level repeatable read
set tran isolation level serializable
go
begin tran
declare @eladva varchar(50)
select @eladva=eladva from termek where id=2 -- vizsgalat
if @eladva='nincs eladva' begin
	waitfor delay '00:00:05' --most terheljk az illet bankszmljt
	update termek set eladva='lefoglalzva', kinek='B' where id=2
	print 'elads megtrtnt'
end else print 'elads sikertelen'
commit tran
go
--a ket kodot egyszerre elinditani
select * from termek --eredmeny: eladva vagy lefoglalozva attol fuggoen, hogy melyik indult hamarabb
update termek set eladva='nincs eladva', kinek=null where id=2

--ez az izolcis elkpzelsnket srti: mindkt tr. azt hiszi, hogy csak o adta el a 2. termket!!!
--(logikai hiba)
--s ez a default!
--VISZONT: mindkt tr. csak 10 s-ig futott... (nem lltak be egyms mg)

--ugyanez repeatable read esetn
--eredmeny:
Transaction (Process ID 53) was deadlocked on lock resources with another process and has been chosen as the deadlock victim. Rerun the transaction.
--mivel mindketto kert egy shared lock-ot, es egyik sem tudta ezt exclusive-ve atalakitani...
--futasidok: 16 ill. 12 s (2 s-ig vart a szerver, hatha feloldodik a deadlock magatol...)
--nincs logikai hiba, csak egy eladas tortent

--ennek a helyzetnek nincs megoldasa (pech): a ket muvelet koze ne tegyunk delay-t...

--ellenorzes:  egyikbol kiszedni a vizsgalatot es kesleltetest, csak update maradjon
--ekkor nem lesz deadlock, es csak egyszer adjuk el.

-- ESETTANULMNY: repjegyes plda, demo (csak egy embernek sikerlhet)
delete jegy

-- rep.jegy foglalas, SQL tranzakcios gyakorlat
-- 2001 szept., Vassanyi Istvan
set transaction isolation level serializable
set xact_abort on 
set nocount on
declare @jszam int, @jid int, @pid int, @utnapja datetime, @napikod smallint
declare @pnev varchar(50), @ind varchar(50), @cel varchar(50)
declare @jegyar money, @egyenleg money, @helyszam smallint

set @jszam=637 set @utnapja='2001.10.23' set @napikod=2 set @pid=2--ezek a parameterek a kliens programbol jonnek
					--feltesszuk, hogy letezo rekordokra utalnak /ezt kulonben vizsgalni kellene/
select @ind=IndAll, @cel=CelAll from JaratTA where Jszam=@jszam
select @pnev=Pnev from Partner where PID=@pid
print 'Jegyfoglals s -vtel ' + @pnev + ' szmra ' + @ind + '-' + @cel + ' viszonylatban.'
print 'Tranzakci indtsa...'
begin transaction
				--van-e eleg penze
select @egyenleg=Egyenleg from Partner where PID=@pid
select @jegyar=Jegyar from JaratTA where Jszam=@jszam
if @egyenleg < @jegyar begin  
	raiserror('A tranzakci sikertelen. A hiba oka: nincs fedezet.', 17,17)
	rollback transaction
	goto vege
end
				--van-e hely
select @jid=JID, @helyszam=HelySzam from Jarat where Jszam=@jszam and UtNapja=@utnapja and NapiKod=@napikod
if @helyszam <= 0 begin
	raiserror('A tranzakci sikertelen. A hiba oka: nincs hely.', 17,17)
	rollback transaction
	goto vege
end
				--van-e mar jegye
if exists (select * from Jegy where PID=@pid and JID=@jid) begin
	raiserror('A tranzakci sikertelen. A hiba oka: a partnernek erre a jratra van mr jegye.', 17,17)
	rollback transaction
	goto vege
end
waitfor delay '00:00:01'
				--tranz. OK
update Partner set Egyenleg=Egyenleg-@jegyar where PID=@pid
update Jarat set Helyszam=Helyszam-1 where JID=@jid
insert Jegy (PID, JID) values (@pid, @jid)
print 'A tranzakci sikeres.'
commit transaction

vege:  --visszateres

go

--teszt: set transaction isolation level serializable hatsa: tovbb tart a (sok) tranzakci


--ami meg nem volt: 
--backup/restore
--jobok
--triggerek