SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

ALTER  PROCEDURE sp_order_process 
--vgignzi a northwind.order_log tblt, s
--egyenknt feldolgozza a legutbbi futs ta keletkezett esemnyeket
AS
/*
order_log tbla status mezje:
0: j, feldolgozatlan esemny
1: esemny feldolgozsa elkezddtt
2: esemny feldolgozsa rendben megtrtnt
3: esemny feldolgozsa hibval megtrtnt
*/
declare @event_id int, @event_type order_event, @order_id int, @orderitem_id int
declare cursor_events cursor forward_only static
--FORWARD_ONLY pecifies that the cursor can only be scrolled from the first to the last row. 
--FETCH NEXT is the only supported fetch option
--STATIC defines a cursor that makes a temporary copy of the data to be used by the cursor. 
--All requests to the cursor are answered from this temporary table in tempdb; 
--therefore, modifications made to base tables are not reflected in the data returned 
--by fetches made to this cursor, and this cursor does not allow modifications.
	for 
	select  event_id, event_type, order_id, orderitem_id
	from order_log where status=0

set xact_abort on --hiba esetn rollback
set nocount on
begin tran --lehetne az egyes esemnyeknek is sajt tranzakci
open cursor_events
fetch next from cursor_events into @event_id, @event_type, @order_id, @orderitem_id
while @@fetch_status = 0
begin
	print 'esemny ID=' + cast(@event_id as varchar(10)) + ', rendels ID=' + cast(@order_id as varchar(10))+' feldolgozsa:'
	update order_log set time_process_begin=getdate(), status=1 where event_id=@event_id
	if @event_type = 'j rendels' begin
		print 'j rendels feldolgozsa...'
		waitfor delay '00:00:01'--a feldolgozs sorn 3-ra lltjuk a statust, ha hiba van
		print 'rendben'
	end else
	if @event_type = 'cmvltozs' begin
		print 'cmvltozs feldolgozsa...'
		waitfor delay '00:00:01'
		print 'rendben'
	end else
	if @event_type = 'mdosult rendels' begin
		print 'mdosult rendels feldolgozsa...'
		waitfor delay '00:00:01'
		print 'rendben'
	end --egyb esemnytpusokkal nem foglalkozunk
	update order_log set time_process_end=getdate(), status=2 where event_id=@event_id		

	fetch next from cursor_events into @event_id, @event_type, @order_id, @orderitem_id
end
commit tran 
close cursor_events 
deallocate cursor_events


