﻿
create or replace function northwind.sp_order_process () returns integer as $_$
--végignézi a northwind.order_log táblát, és
--egyenként feldolgozza a legutóbbi futás óta keletkezett eseményeket
--a feldolgozott eseményke számáét adja vissza

/*
order_log tábla status mezője:
0: új, feldolgozatlan esemény
1: esemény feldolgozása elkezdődött
2: esemény feldolgozása rendben megtörtént
3: esemény feldolgozása hibával megtörtént
*/

declare var_logrecord record;
	var_i integer := 0;
begin
	for var_logrecord in select event_id, event_type, order_id, orderitem_id
		from northwind.order_log where status=0 
	loop
		raise notice  'esemény ID=%, rendelés ID=% feldolgozása:', 
					var_logrecord.event_id, var_logrecord.order_id;
		update northwind.order_log set time_process_begin=now(), status=1 
							where event_id=var_logrecord.event_id;
		case var_logrecord.event_type
		when 'új rendelés' then
			raise notice 'új rendelés feldolgozása...';
			perform pg_sleep(1); --a feldolgozás során 3-ra állítjuk a statust, ha hiba van
		when 'címváltozás' then
			raise notice 'címváltozás feldolgozása...';
			perform pg_sleep(1); --a feldolgozás során 3-ra állítjuk a statust, ha hiba van
		when 'módosult rendelés' then
			raise notice 'módosult rendelés feldolgozása...';
			perform pg_sleep(1); --a feldolgozás során 3-ra állítjuk a statust, ha hiba van
		end case;	 --egyéb eseménytípusokkal nem foglalkozunk
	
		update northwind.order_log set time_process_end=now(), status=2, 
				process_duration=extract(second from age(time_process_end, time_process_begin)) 
			where event_id=var_logrecord.event_id;

		var_i := var_i + 1;
	end loop; 
	return var_i;
end;
$_$ language plpgsql;

--select northwind.sp_order_process();