﻿
/* trigger, speciális függvény, ami hozzá van kötve egy táblához:
CREATE FUNCTION trigger_fv_neve() RETURNS trigger AS...

CREATE TRIGGER trigger_neve BEFORE INSERT OR UPDATE ON tábla_neve
    FOR EACH ROW EXECUTE PROCEDURE trigger_fv_neve();

--speciális táblák a new és az old
--speciális változók: TG_OP stb.

*/
    
create or replace function northwind.fn_log_order() returns trigger AS $_$
    	declare var_orderid integer;
	declare var_esem_tipus northwind.event_type; --van enum adattipusunk
    begin
	var_orderid := new.orderid;

	if (TG_OP = 'INSERT') then	--uj rekord
		var_esem_tipus := 'új rendelés';
		raise notice 'figyelmeztetés: új rendelés (orderid: %)', var_orderid;
        elsif (old.shipaddress != new.shipaddress) or (old.shipcity != new.shipcity) then  
					--cím változás
					--vigyázat, ha a régi érték NULL volt, nem jön be
					--további vizsgálatok kellenek, ha ilyen lehet
					--ennél jobb volt az MSSQL-es if update(...)
		var_esem_tipus := 'címváltozás';
		raise notice 'figyelmeztetés: címváltozás (orderid: %)', var_orderid;
	else 			--egyéb változás
		var_esem_tipus := 'módosult rendelés';
		raise notice 'figyelmeztetés: módosult rendelés (orderid: %)', var_orderid;	
	end if;
	
	if var_esem_tipus is not null then
		insert into northwind.order_log (event_type, order_id) 
			values (var_esem_tipus, var_orderid); 
					--time_create automatikusan kitöltődik, status -> 0
	end if;
	return null;
    end;	
$_$ LANGUAGE plpgsql;

drop trigger tr_log_order ON northwind.orders;

CREATE TRIGGER tr_log_order AFTER INSERT OR UPDATE ON northwind.orders
    FOR EACH ROW EXECUTE PROCEDURE northwind.fn_log_order();